package dev.garrettmills.starship.hyperlink.util;

/**
 * Token format:
 * "hyperlink|https://hyperlink.url|token"
 */
public class LoginToken {
    public static boolean isValidLoginToken(String token) {
        try {
            new LoginToken(token);
            return true;
        } catch (InvalidLoginTokenException e) {
            return false;
        }
    }

    private String server;
    private String token;

    public LoginToken(String token) throws InvalidLoginTokenException {
        String[] parts = token.split("\\|");
        if ( parts.length != 3 || !parts[0].equals("hyperlink")) {
            throw new InvalidLoginTokenException();
        }

        this.server = parts[1];
        this.token = parts[2];
    }

    public String getServer() {
        return server;
    }

    public String getToken() {
        return token;
    }
}
